TITLE BarIcon.asm 

; Pone un icono en la barra de tareas de Windows.
; Por n u M I T_o r, 1999.

include         windows.inc

includelib      shell32.lib
includelib      kernel32.lib
includelib      user32.lib
includelib      comctl32.lib
 
ID_ICON         equ     4001
IDC_BUTTON      equ     3001
IDC_BUTTON1     equ     1004
ID_TIMER        equ     2001

IDOK            equ     1

NIM_ADD         equ       0      ; Agrega icono al area de status.
NIM_DELETE      equ       2      ; Borra o elimina icono del area de status.
NIM_MODIFY      equ       1      ; Modifica un icono en el area de status.

ID_ITEM0        equ     0910
ID_ITEM1        equ     0911
ID_ITEM2        equ     0912
ID_ITEM3        equ     0913
ID_ITEM4        equ     0914
ID_ITEM5        equ     0915
ID_ITEM6        equ     0916
ID_ITEM7        equ     0917
ID_URL          equ     0918

CREATE_NEW_PROCESS_GROUP equ 200h
CREATE_NEW_CONSOLE equ 10h
DETACHED_PROCESS equ  8

NOTIFYICONDATA STRUC
        cbSize                  DWORD   ?
        hWnd                    HWND    ?  
        uID                     UINT    ?
        uFlags                  UINT    ?
        uCallbackMessage        UINT    ?
        hIcon                   HICON   ?
        szTip                   db      64 dup (?)
NOTIFYICONDATA ENDS
PNOTIFYICONDATA     TYPEDEF         PTR     NOTIFYICONDATA

ITEMMENUS       STRUCT
         uSize                  dd      sizeof ITEMMENUS
         pStrItem               db      24 dup (?)
         ID_MENUITEM            UINT    ?
ITEMMENUS       ENDS
PITEMMENUS      TYPEDEF         PTR     ITEMMENUS
         
LPSITEMSMENU    TYPEDEF         LPDWORD

        Shell_NotifyIcon PROTO :DWORD,:DWORD
        ShellExecuteA    PROTO :HWND,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        ShellExecute     equ   ShellExecuteA
        lstrcpy          PROTO :DWORD,:DWORD
        DialogProc       PROTO :HWND,:UINT,:WPARAM,:LPARAM
        RtlZeroMemory    PROTO :LPSTARTUPINFO,:DWORD
        ZeroMemory       equ   RtlZeroMemory
                
        PopUpMenu        PROTO  :HWND
        MinAllWin        PROTO  :HWND
        salir            PROTO 
         
        .data?
        hInstance       HINSTANCE ?
        hIcon           HANDLE    ?
        dwMessage       DWORD     ?
        CommandLine     DWORD     ?
        nid             NOTIFYICONDATA <>
        sui             STARTUPINFO <>
        pi              PROCESS_INFORMATION <>
        
        .data
        app1            db      "NOTEPAD.EXE",0
        app2            db      "EXPLORER.EXE",0
        app3            db      "COMMAND.COM",0
        nApp            db      'FLY v0.1',0 
        DlgName         db      'IconDlg',0
        URL             db      'http://members.nbci.com/numit_or/asm.html',0
	ShellOperation  db      'open'
        ChangeWin       dd      0BFF61FCBh
        LastActive      dd      0BFF62337h

public main
        .code 
main: 
        invoke GetModuleHandle,NULL
        mov hInstance,eax
        invoke GetCommandLine 
        invoke WinMain, hInstance,NULL,CommandLine,SW_SHOWDEFAULT
        invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD 
    mov  eax, OFFSET DialogProc
    lea  edx,DlgName
    invoke DialogBoxParamA,hInst,edx,NULL,eax,NULL 
    ret 
WinMain endp 

DialogProc proc uses esi edi ebx \
	hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg 
    .IF eax==WM_INITDIALOG

; Limpiar la estructura STARTUPINFO
        invoke ZeroMemory,ADDR sui,SIZEOF STARTUPINFO

; Establecer los valores de la estructura STARTUPINFO
        mov     sui.cb,SIZEOF STARTUPINFO
        mov     nid.cbSize,SIZEOF NOTIFYICONDATA
        mov     eax,hDlg
        mov     nid.hWnd,eax
        mov     eax,ID_ICON
        mov     nid.uID,eax
        mov     nid.uFlags,7
        mov     nid.uCallbackMessage,WM_COMMAND

; Obtener el manejador de icono
        invoke  LoadIcon,hInstance,ID_ICON
        mov     nid.hIcon,eax  ;

; Cadena que muestra el cono cuando el cursor est sobre l
        lea     edi,nid.szTip
        invoke  lstrcpy,edi,ADDR nApp

; Poner el icono del programa en la barra de tareas
        invoke  Shell_NotifyIcon,NIM_ADD,ADDR nid

; Poner un temporizador que cierre la ventana inicial
        invoke  SetTimer,hDlg,ID_TIMER,01388h,NULL

    .ELSEIF eax==WM_COMMAND 
        mov eax,wParam 
        .IF ax==ID_ICON
                mov     eax,lParam
                .IF     eax==WM_RBUTTONUP

	; Desplegar el men emergente
                        mov    eax,hDlg
                        push   eax
                        call   PopUpMenu
                .ELSEIF eax==WM_LBUTTONDBLCLK
                        call   salir
                .ENDIF
        .ELSEIF ax==ID_ITEM1
		; Abrir el block de notas         
               		invoke ShellExecute,hDlg,0,ADDR app1,0,0,5        
        .ELSEIF ax==ID_ITEM2
		; Abrir el explorador
                        invoke ShellExecute,hDlg,0,ADDR app2,0,0,5                        
        .ELSEIF ax==ID_ITEM3
		; Abrir cnsola de comandos
                        invoke ShellExecute,hDlg,0,ADDR app3,0,0,5
        .ELSEIF ax==ID_ITEM4 
		; Mostrar la ventana de ayuda                          
                        invoke  ShowWindow,hDlg,5
                        invoke  UpdateWindow,hDlg
        .ELSEIF ax==ID_ITEM6
		; Cerrar el programa
                        invoke  LoadIcon,hInstance,ID_ICON
                        mov     nid.hIcon,eax
                        invoke  Shell_NotifyIcon,NIM_DELETE,ADDR nid
                        invoke  EndDialog,hDlg,0                   
        .ELSEIF ax==ID_ITEM7
		; Salir de Windows
                        call    salir        
        .ELSEIF ax==IDC_BUTTON1
		; Ir a la pgina web de n u M I T_o r                        
                        invoke  ShellExecute,0,0,ADDR URL,0,0,0
        .ELSEIF ax==IDOK
		; Ocultar la ventana de informacin
                invoke  ShowWindow,hDlg,0
                invoke  UpdateWindow,hDlg       
        .ENDIF

    .ELSEIF eax==WM_TIMER 
        invoke KillTimer,hDlg,ID_TIMER
        invoke SendMessageA,hDlg,WM_COMMAND,IDOK,NULL

    .ELSE   
        mov eax,FALSE
        ret

    .ENDIF
        mov     eax,TRUE
        ret
DialogProc endp

        end     main
